using System;
using Microsoft.BizTalk.ExplorerOM;
using System.Xml;

namespace BizTalk_Port_Changer
{
	/// <summary>
	/// Summary description for PortDetail.
	/// </summary>
	public class PortDetail : IComparable
	{
		protected string PortName;
		protected string PortAddress;
		protected string PortConfig;
		protected string PortType;
		protected string PortDirection;
		protected string PortUsername;
		protected string PortPassword;
		protected string PortLocationName;
		protected int PortLocationCount;



		public string Name // this will be displayed in the column Header in the DataGrid 
		{
			get
			{
				return PortName; // this will be displayed in the data field of the DataGrid 
			}
			set
			{
				PortName =  value;
			}
		}
		public string Address // this will be displayed in the column Header in the DataGrid 
		{
			get
			{
				return PortAddress; // this will be displayed in the data field of the DataGrid 
			}
			set
			{
				PortAddress =  value;
			}
		}
		public string Config // this will be displayed in the column Header in the DataGrid 
		{
			get
			{
				return PortConfig; // this will be displayed in the data field of the DataGrid 
			}
			set
			{
				PortConfig =  value;
			}
		}
		public string Type // this will be displayed in the column Header in the DataGrid 
		{
			get
			{
				return PortType; // this will be displayed in the data field of the DataGrid 
			}
			set
			{
				PortType =  value;
			}
		}

		public string Password // this will be displayed in the column Header in the DataGrid 
		{
			get
			{
				return PortPassword; // this will be displayed in the data field of the DataGrid 
			}
			set
			{
				PortPassword =  value;
			}
		}

		public string Username // this will be displayed in the column Header in the DataGrid 
		{
			get
			{
				return PortUsername; // this will be displayed in the data field of the DataGrid 
			}
			set
			{
				PortUsername =  value;
			}
		}

		public string Direction 
		{
			get
			{
				return PortDirection; 
			}
			set
			{
				PortDirection =  value;
			}
		}

		public string LocationName 	
		{
			get
			{
				return PortLocationName; 
			}
			set
			{
				PortLocationName =  value;
			}

		}
		public int LocationCount 	
		{
			get
			{
				return PortLocationCount; 
			}
			set
			{
				PortLocationCount =  value;
			}

		}
		public PortDetail()
		{
			//
			// TODO: Add constructor logic here
			//
		}
		public PortDetail(SendPort input)
		{
			PortName = input.Name;
			PortAddress = input.PrimaryTransport.Address;
			PortConfig = UnescapeXml(input.PrimaryTransport.TransportTypeData);
			PortType = input.PrimaryTransport.TransportType.Name;
			PortDirection = "Send";		
			// Find Password
			PortPassword= "";
			// SQL  
			try 
			{
				if (PortType == "SQL")
				{
					string[] tmp = input.PrimaryTransport.TransportTypeData.Split(';');
					for (int i = 0;i < tmp.Length;i++)
					{
						if (tmp[i].ToUpper().IndexOf("PASSWORD")  >= 0)
						{
							string[] tmppwd = tmp[i].Split('=');
							if (tmppwd.Length == 2)
							{
								PortPassword = tmppwd[1];
							}						
						}
						if (tmp[i].ToUpper().IndexOf("USER ID")  >= 0)
						{
							string[] tmpusr = tmp[i].Split('=');
							if (tmpusr.Length == 2)
							{
								PortUsername = tmpusr[1];
							}
							
						}

					}
				}
				else if (PortType == "FTP")
				{
					string tmp = input.PrimaryTransport.TransportTypeData;
					tmp = UnescapeXml(tmp);
					XmlDocument  xmldoc = new XmlDocument();
					xmldoc.LoadXml(tmp);
					XmlNodeList xmlnode = xmldoc.GetElementsByTagName("password");
					PortPassword = xmlnode[0].InnerText;
					xmlnode = xmldoc.GetElementsByTagName("userName");
					PortUsername = xmlnode[0].InnerText;
				}
			}
			catch(Exception ex)
			{
			}
		}
		public PortDetail(ReceivePort input)
		{
			PortName = input.Name;
			PortAddress = input.PrimaryReceiveLocation.Address;
			PortConfig = UnescapeXml(input.PrimaryReceiveLocation.TransportTypeData);
			PortType = input.PrimaryReceiveLocation.TransportType.Name;
			PortDirection = "Receive";
			// Find Password
			PortPassword= "";
			PortLocationCount = input.ReceiveLocations.Count;
			
			
			try 
			{				
				if (PortType == "SQL")
				{
					string[] tmp = input.PrimaryReceiveLocation.TransportTypeData.Split(';');
					for (int i = 0;i < tmp.Length;i++)
					{
						if (tmp[i].ToUpper().IndexOf("PASSWORD")  >= 0)
						{
							string[] tmppwd = tmp[i].Split('=');
							if (tmppwd.Length == 2)
							{
								PortPassword = tmppwd[1];
							}
						
						}
						if (tmp[i].ToUpper().IndexOf("USER ID")  >= 0)
						{
							string[] tmpusr = tmp[i].Split('=');
							if (tmpusr.Length == 2)
							{
								PortUsername = tmpusr[1];
							}
							
						}
					}
				}
				else if (PortType == "FTP")
				{
					string tmp = input.PrimaryReceiveLocation.TransportTypeData;
					tmp = UnescapeXml(tmp);
					XmlDocument  xmldoc = new XmlDocument();
					xmldoc.LoadXml(tmp);
					XmlNodeList xmlnode = xmldoc.GetElementsByTagName("password");
					PortPassword = xmlnode[0].InnerText;					
					xmlnode = xmldoc.GetElementsByTagName("userName");
					PortUsername = xmlnode[0].InnerText;
				}
			}
			catch(Exception ex)
			{
			}


				
		}

		public static string UnescapeXml(  string s )
		{
			string unxml = s;
		
			// replace entities with literal values
			unxml = unxml.Replace( "&apos;", "'" );
			unxml = unxml.Replace( "&quot;", "\"" );
			unxml = unxml.Replace( "&gt;", ">" );
			unxml = unxml.Replace( "&lt;", "<" );
			unxml = unxml.Replace( "&amp;", "&" );
	
			return unxml;
		}

		public static string EscapeXml(  string s )
		{
			string unxml = s;
		
			// replace entities with literal values
			unxml = unxml.Replace( "'","&apos;" );
			unxml = unxml.Replace( "\"","&quot;" );
			unxml = unxml.Replace( ">" ,"&gt;" );
			unxml = unxml.Replace( "<" ,"&lt;" );
			unxml = unxml.Replace( "&", "&amp;" );
	
			return unxml;
		}

		public static string ChangeUsername(string PortType,string TransportTypeData,string newUsername)
		{
			
			try 
			{
				if (PortType == "SQL")
				{
					string[] tmp = TransportTypeData.Split(';');
					for (int i = 0;i < tmp.Length;i++)
					{
						
						if (tmp[i].ToUpper().IndexOf("USER ID")  >= 0)
						{
							string[] tmpusr = tmp[i].Split('=');
							if (tmpusr.Length == 2)
							{
								
								tmp[i] = tmpusr[0] + "=" + newUsername;								
							}
							
						}
					}
					TransportTypeData = String.Join(";",tmp);

				}

				return TransportTypeData;
			}
			catch(Exception ex)
			{
				throw ex;
				
			}
			

		}
		public static string ChangePassword(string PortType,string TransportTypeData,string newPassword)
		{
			
			try 
			{
				if (PortType == "SQL")
				{
					string[] tmp = TransportTypeData.Split(';');
					for (int i = 0;i < tmp.Length;i++)
					{
						
						if (tmp[i].ToUpper().IndexOf("PASSWORD")  >= 0)
						{
							string[] tmpusr = tmp[i].Split('=');
							if (tmpusr.Length == 2)
							{
								
								tmp[i] = tmpusr[0] + "=" + newPassword;								
							}
							
						}
					}
					TransportTypeData = String.Join(";",tmp);

				}

				
				return TransportTypeData;
			}
			catch(Exception ex)
			{
				throw ex;
				
			}
		}

		public int CompareTo(object obj)
		{
			PortDetail Compare = (PortDetail)obj;
			int result = this.Name.CompareTo(Compare.Name);
			if (result == 0)
				result = this.Name.CompareTo(Compare.Name);
			return result;
		}
  }
	
}
